diff --git a/gcc/tree-vect-stmts.c b/gcc/tree-vect-stmts.c
index 40c5825..6558330 100644
--- a/gcc/tree-vect-stmts.c
+++ b/gcc/tree-vect-stmts.c
@@ -9524,7 +9524,7 @@ vect_transform_stmt (gimple *stmt, gimple_stmt_iterator *gsi,
       if (!STMT_VINFO_LIVE_P (stmt_info))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
                              "stmt not supported.\n");
 	  gcc_unreachable ();
 	}
@@ -9892,10 +9892,9 @@ vect_is_simple_use (tree operand, vec_info *vinfo,
 
   if (optinfo_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location,
-                       "vect_is_simple_use: operand ");
-      dump_generic_expr (MSG_NOTE, TDF_SLIM, operand);
-      dump_printf (MSG_NOTE, "\n");
+      OPTINFO_VECT_REMARK
+	<< "vect_is_simple_use: operand "
+	<< slim (operand);
     }
 
   if (CONSTANT_CLASS_P (operand))
@@ -9913,8 +9912,8 @@ vect_is_simple_use (tree operand, vec_info *vinfo,
   if (TREE_CODE (operand) != SSA_NAME)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
-			 "not ssa-name.\n");
+	OPTINFO_VECT_FAILURE
+	  << "not ssa-name";
       return false;
     }
 
@@ -9927,8 +9926,8 @@ vect_is_simple_use (tree operand, vec_info *vinfo,
   *def_stmt = SSA_NAME_DEF_STMT (operand);
   if (optinfo_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "def_stmt: ");
-      dump_gimple_stmt (MSG_NOTE, TDF_SLIM, *def_stmt, 0);
+      OPTINFO_VECT_REMARK
+	<< "def_stmt: " << *def_stmt;
     }
 
   if (! vect_stmt_in_region_p (vinfo, *def_stmt))
@@ -9941,35 +9940,35 @@ vect_is_simple_use (tree operand, vec_info *vinfo,
 
   if (optinfo_enabled_p ())
     {
-      dump_printf_loc (MSG_NOTE, vect_location, "type of def: ");
+      pending_optinfo po = OPTINFO_VECT_REMARK << "type of def: ";
       switch (*dt)
 	{
 	case vect_uninitialized_def:
-	  dump_printf (MSG_NOTE, "uninitialized\n");
+	  po << "uninitialized";
 	  break;
 	case vect_constant_def:
-	  dump_printf (MSG_NOTE, "constant\n");
+	  po << "constant";
 	  break;
 	case vect_external_def:
-	  dump_printf (MSG_NOTE, "external\n");
+	  po << "external";
 	  break;
 	case vect_internal_def:
-	  dump_printf (MSG_NOTE, "internal\n");
+	  po << "internal";
 	  break;
 	case vect_induction_def:
-	  dump_printf (MSG_NOTE, "induction\n");
+	  po << "induction";
 	  break;
 	case vect_reduction_def:
-	  dump_printf (MSG_NOTE, "reduction\n");
+	  po << "reduction";
 	  break;
 	case vect_double_reduction_def:
-	  dump_printf (MSG_NOTE, "double reduction\n");
+	  po << "double reduction";
 	  break;
 	case vect_nested_cycle:
-	  dump_printf (MSG_NOTE, "nested cycle\n");
+	  po << "nested cycle";
 	  break;
 	case vect_unknown_def_type:
-	  dump_printf (MSG_NOTE, "unknown\n");
+	  po << "unknown";
 	  break;
 	}
     }
@@ -9977,8 +9976,7 @@ vect_is_simple_use (tree operand, vec_info *vinfo,
   if (*dt == vect_unknown_def_type)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
-                         "Unsupported pattern.\n");
+        OPTINFO_VECT_FAILURE << "Unsupported pattern";
       return false;
     }
 
@@ -9990,8 +9988,7 @@ vect_is_simple_use (tree operand, vec_info *vinfo,
       break;
     default:
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
-                         "unsupported defining stmt:\n");
+        OPTINFO_VECT_FAILURE << "unsupported defining stmt:";
       return false;
     }
 
diff --git a/gcc/tree-vectorizer.h b/gcc/tree-vectorizer.h
index 5411b37..206f0f3 100644
--- a/gcc/tree-vectorizer.h
+++ b/gcc/tree-vectorizer.h
@@ -1393,8 +1393,22 @@ extern pending_optinfo
 emit_optinfo_at_vect_location (const location &impl_location,
 			       enum opt_record_kind kind);
 
-#define EMIT_OPTINFO_AT_VECT_LOCATION(KIND) \
-  (emit_optinfo_at_vect_location (OPTINFO_IMPL_LOCATION, (KIND)))
+/* Emit that a successful optimization happened at the vect location.  */
+
+#define OPTINFO_VECT_SUCCESS \
+  (emit_optinfo_at_vect_location (OPTINFO_IMPL_LOCATION, OPT_RECORD_SUCCESS))
+
+/* Emit that a failed optimization happened at the vect location.  */
+
+#define OPTINFO_VECT_FAILURE \
+  (emit_optinfo_at_vect_location (OPTINFO_IMPL_LOCATION, OPT_RECORD_FAILURE))
+
+/* Emit a remark relating to an optimization at the vect location.  */
+
+#define OPTINFO_VECT_REMARK \
+  (emit_optinfo_at_vect_location (OPTINFO_IMPL_LOCATION, OPT_RECORD_REMARK))
+
+/* FIXME.  */
 
 #define VECT_OPTINFO_SCOPE(NAME) \
   OPTINFO_SCOPE ((NAME), vect_location_thing)
-- 
1.8.5.3

